CIMANAGE-5: update bootstrap for csit-vpp-verify-weekly job
[csit.git] / bootstrap-vpp-verify-weekly.sh
1 #!/bin/bash
2 # Copyright (c) 2016 Cisco and/or its affiliates.
3 # Licensed under the Apache License, Version 2.0 (the "License");
4 # you may not use this file except in compliance with the License.
5 # You may obtain a copy of the License at:
6 #
7 #     http://www.apache.org/licenses/LICENSE-2.0
8 #
9 # Unless required by applicable law or agreed to in writing, software
10 # distributed under the License is distributed on an "AS IS" BASIS,
11 # WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
12 # See the License for the specific language governing permissions and
13 # limitations under the License.
14
15 set -x
16
17 cat /etc/hostname
18 cat /etc/hosts
19
20 export DEBIAN_FRONTEND=noninteractive
21 sudo apt-get -y update
22 sudo apt-get -y install libpython2.7-dev python-virtualenv
23
24 function ssh_do() {
25     echo
26     echo "### "  ssh $@
27     ssh -i priv_key -o StrictHostKeyChecking=no $@
28 }
29
30 VIRL_SERVER=10.30.51.28
31 VIRL_USERNAME=jenkins-in
32 VIRL_PKEY=priv_key
33
34 rm -f ${VIRL_PKEY}
35 cat > ${VIRL_PKEY} <<EOF
36 -----BEGIN RSA PRIVATE KEY-----
37 MIIEpQIBAAKCAQEA+IHXq87GcqMR1C47rzx6Cbip5Ghq8pKrbqKrP5Nf41HcYrT6
38 GOXl9nFWKsMOzIlIn+8y7Il27eZh7csQGApbg8QLiHMtcYEmWNzKZpkqg4nuAPxX
39 VXwlKgnKX902SrET9Gp9TDayiHtCRWVfrlPPPSA0UEXW6BjLN/uHJ+W/Xzrrab+9
40 asBVa05vT2W6n0KJ66zfCaeDM912mQ6SttscAwFoWDmdHlegiVqrlIG2ABxOvxxz
41 L3dM3iSmlmQlzv9bThjo+nI4KFYh6m5wrZmAo5r/4q9CIJc21HVnTqkGOWJIZz6J
42 73lePJVSq5gYqaoGw3swFEA/MDkOx7baWKSoLQIDAQABAoIBAQCNBeolNp+JWJ76
43 gQ4fwLsknyXSV6sxYyhkDW4PEwwcTU06uqce0AAzXVffxne0fMe48x47+zqBgPbb
44 4huM+Pu8B9nfojUMr5TaYtl9Zbgpk3F8H7dT7LKOa6XrxvZTZrADSRc30+Z26zPN
45 e9zTaf42Gvt0/l0Zs1BHwbaOXqO+XuwJ3/F9Sf3PQYWXD3EOWjpHDP/X/1vAs6lV
46 SLkm6J/9KKE1m6I6LTYjIXuYt4SXybW6N2TSy54hhQtYcDUnIU2hR/PHVWKrGA0J
47 kELgrtTNTdbML27O5gFWU4PLUEYTZ9fN11D6qUZKxLcPOiPPHXkiILMRCCnG5DYI
48 ksBAU/YlAoGBAPxZO9VO18TYc8THV1nLKcvT2+1oSs1UcA2wNQMU55t910ZYinRa
49 MRwUhMOf8Mv5wOeiZaRICQB1PnVWtDVmGECgPpK6jUxqAwn8rgJcnoafLGL5YKMY
50 RVafTe6N5LXgCaOcJrk21wxs6v7ninEbUxxc575urOvZMBkymDw91dwbAoGBAPwa
51 YRhKhrzFKZzdK0RadVjnxKvolUllpoqqg3XuvmeAJHAOAnaOgVWq68NAcp5FZJv0
52 2D2Up7TX8pjf9MofP1SJbcraKBpK4NzfNkA0dSdEi+FhVofAJ9umB2o5LW1n7sab
53 UIrjsdzSJK/9Zb9yTTHPyibYzNEgaJV1HsbxfEFXAoGAYO2RmvRm0phll18OQVJV
54 IpKk9kLKAKZ/R/K32hAsikBC8SVPQTPniyaifFWx81diblalff2hX4ipTf7Yx24I
55 wMIMZuW7Im/R7QMef4+94G3Bad7p7JuE/qnAEHJ2OBnu+eYfxaK35XDsrq6XMazS
56 NqHE7hOq3giVfgg+C12hCKMCgYEAtu9dbYcG5owbehxzfRI2/OCRsjz/t1bv1seM
57 xVMND4XI6xb/apBWAZgZpIFrqrWoIBM3ptfsKipZe91ngBPUnL9s0Dolx452RVAj
58 yctHB8uRxWYgqDkjsxtzXf1HnZBBkBS8CUzYj+hdfuddoeKLaY3invXLCiV+PpXS
59 U4KAK9kCgYEAtSv0m5+Fg74BbAiFB6kCh11FYkW94YI6B/E2D/uVTD5dJhyEUFgZ
60 cWsudXjMki8734WSpMBqBp/J8wG3C9ZS6IpQD+U7UXA+roB7Qr+j4TqtWfM+87Rh
61 maOpG56uAyR0w5Z9BhwzA3VakibVk9KwDgZ29WtKFzuATLFnOtCS46E=
62 -----END RSA PRIVATE KEY-----
63 EOF
64 chmod 600 priv_key
65
66 # Temporarily download VPP packages from nexus.fd.io
67 rm -f *.deb
68 if [ "${#}" -ne "0" ]; then
69     arr=(${@})
70     echo ${arr[0]}
71 else
72     VPP_STABLE_VER="1.0.0-437~g8f15e92_amd64"
73     VPP_REPO_URL="https://nexus.fd.io/service/local/repositories/fd.io.dev/content/io/fd/vpp"
74     wget -q "${VPP_REPO_URL}/vpp/${VPP_STABLE_VER}/vpp-${VPP_STABLE_VER}.deb" || exit
75     wget -q "${VPP_REPO_URL}/vpp-dbg/${VPP_STABLE_VER}/vpp-dbg-${VPP_STABLE_VER}.deb" || exit
76     wget -q "${VPP_REPO_URL}/vpp-dev/${VPP_STABLE_VER}/vpp-dev-${VPP_STABLE_VER}.deb" || exit
77     wget -q "${VPP_REPO_URL}/vpp-dpdk-dev/${VPP_STABLE_VER}/vpp-dpdk-dev-${VPP_STABLE_VER}.deb" || exit
78     wget -q "${VPP_REPO_URL}/vpp-dpdk-dkms/${VPP_STABLE_VER}/vpp-dpdk-dkms-${VPP_STABLE_VER}.deb" || exit
79     wget -q "${VPP_REPO_URL}/vpp-lib/${VPP_STABLE_VER}/vpp-lib-${VPP_STABLE_VER}.deb" || exit
80 fi
81
82 VPP_DEBS=(*.deb)
83 echo ${VPP_DEBS[@]}
84 VIRL_DIR_LOC="/tmp"
85 VPP_DEBS_FULL=(${VPP_DEBS[@]})
86
87 # Prepend directory location at remote host to deb file list
88 for index in "${!VPP_DEBS_FULL[@]}"; do
89     VPP_DEBS_FULL[${index}]=${VIRL_DIR_LOC}/${VPP_DEBS_FULL[${index}]}
90 done
91
92 echo "Updated file names: " ${VPP_DEBS_FULL[@]}
93
94 # Copy the files to VIRL host
95 scp -i ${VIRL_PKEY} -o StrictHostKeyChecking=no *.deb \
96     ${VIRL_USERNAME}@${VIRL_SERVER}:${VIRL_DIR_LOC}/
97
98 result=$?
99 if [ "${result}" -ne "0" ]; then
100     echo "Failed to copy vpp deb files to virl host"
101     echo ${result}
102     exit ${result}
103 fi
104
105 # Start a simulation on VIRL server
106 echo "Starting simulation on VIRL server"
107
108 function stop_virl_simulation {
109     ssh -i priv_key -o StrictHostKeyChecking=no ${VIRL_USERNAME}@${VIRL_SERVER}\
110         "/home/jenkins-in/testcase-infra/bin/stop-testcase ${VIRL_SID}"
111 }
112
113 VIRL_SID=$(ssh -i priv_key -o StrictHostKeyChecking=no \
114     ${VIRL_USERNAME}@${VIRL_SERVER} \
115     "/home/jenkins-in/testcase-infra/bin/start-testcase -c double-ring-nested ${VPP_DEBS_FULL[@]}")
116 retval=$?
117 if [ "$?" -ne "0" ]; then
118     echo "VIRL simulation start failed"
119     exit ${retval}
120 fi
121
122 if [[ ! "${VIRL_SID}" =~ session-[a-zA-Z0-9_]{6} ]]; then
123     echo "No VIRL session ID reported."
124     exit 127
125 fi
126
127 # Upon script exit, cleanup the simulation execution
128 trap stop_virl_simulation EXIT
129 echo ${VIRL_SID}
130
131 ssh_do ${VIRL_USERNAME}@${VIRL_SERVER} cat /scratch/${VIRL_SID}/topology.yaml
132
133 # Download the topology file from virl session
134 scp -i ${VIRL_PKEY} -o StrictHostKeyChecking=no \
135     ${VIRL_USERNAME}@${VIRL_SERVER}:/scratch/${VIRL_SID}/topology.yaml \
136     topologies/enabled/topology.yaml
137
138 retval=$?
139 if [ "$?" -ne "0" ]; then
140     echo "Failed to copy topology file from VIRL simulation"
141     exit ${retval}
142 fi
143
144
145 virtualenv env
146 . env/bin/activate
147
148 echo pip install
149 pip install -r requirements.txt
150
151
152 # There are used three iterations of tests there to check
153 # the stability and reliability of the results
154 for test_set in 1 2 3
155 do
156     echo
157     echo ${test_set}. test loop
158     PYTHONPATH=`pwd` pybot -L TRACE \
159         -v TOPOLOGY_PATH:topologies/enabled/topology.yaml \
160         --include vm_envAND3_node_single_link_topo \
161         --include vm_envAND3_node_double_link_topo \
162         --exclude PERFTEST \
163         --noncritical EXPECTED_FAILING \
164         --output log_test_set${test_set} \
165         tests/
166 done
167
168 rebot --output output.xml ./log_test_set1.xml ./log_test_set2.xml ./log_test_set3.xml
169
170 rm -f ./log_test_set1.xml ./log_test_set2.xml ./log_test_set3.xml

©2016 FD.io a Linux Foundation Collaborative Project. All Rights Reserved.
Linux Foundation is a registered trademark of The Linux Foundation. Linux is a registered trademark of Linus Torvalds.
Please see our privacy policy and terms of use.